//+------------------------------------------------------------------+
//|                                                       #dtosc.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"


#property indicator_separate_window
#property indicator_buffers    4
#property indicator_color1     DeepSkyBlue
#property indicator_width1     2
#property indicator_color2     OrangeRed
#property indicator_style2     STYLE_DASH
#property indicator_color3     LimeGreen
#property indicator_width3     1
#property indicator_color4     Crimson
#property indicator_width4     1
#property indicator_level1     10
#property indicator_level2     90
#property indicator_levelcolor Magenta

//
//
//
//
//

extern string  TimeFrame            = "Current time frame";
extern int     RsxLength            = 14;
extern int     OmaLength            = 5;
extern double  OmaSpeed             = 8.0;
extern bool    OmaAdaptive          = true;
extern int     PeriodStoch          = 8;
extern int     PeriodSK             = 5;
extern int     PeriodSD             = 3;
extern int     HighLowPeriod        = 30;
extern bool    ShowChannel          = true;   
extern int     MAMode               = 3; 
extern bool    Interpolate          = true;
   
extern string  _                    = "alerts settings";
extern bool    alertsOn             = true;
extern bool    alertsOnCurrent      = true;
extern bool    alertsMessage        = true;
extern bool    alertsSound          = false;
extern bool    alertsEmail          = false;
   
extern string  __                   = "arrows settings";
extern bool   ShowArrows            = true;
extern string arrowsIdentifier      = "DT osc channel arrows";
extern color  arrowsUpColor         = Lime;
extern color  arrowsDnColor         = Orange;

   
//
//
//
//
//

double SK[];
double SD[];
double LowBuffer[];
double HighBuffer[];
double rsx[];
double storsx[];
double trend[];
double wrkBuffer[][13];
double stored[][7];

//
//
//
//
//

string IndicatorFileName;
int    timeFrame;
bool   returnBars;
bool   calculateValue;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
      IndicatorBuffers(7);
      SetIndexBuffer(0,SK);
      SetIndexBuffer(1,SD);
      SetIndexBuffer(2,LowBuffer);
      SetIndexBuffer(3,HighBuffer);
      SetIndexBuffer(4,rsx);
      SetIndexBuffer(5,storsx);
      SetIndexBuffer(6,trend);
      
      OmaLength = MathMax(OmaLength,   1);
      OmaSpeed  = MathMax(OmaSpeed ,-1.5);
      
      
      
      
      if (ShowChannel)
            {
               SetIndexStyle(2,DRAW_LINE);
               SetIndexStyle(3,DRAW_LINE);
            }
         else      
            {
               SetIndexStyle(2,DRAW_NONE);
               SetIndexStyle(3,DRAW_NONE);
            }

   //
   //
   //
   //
   //
   
      IndicatorFileName = WindowExpertName();
      returnBars        = (TimeFrame == "returnBars");     if (returnBars)     return(0);
      calculateValue    = (TimeFrame == "calculateValue"); if (calculateValue) return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);   

   //
   //
   //
   //
   //
   
   IndicatorShortName(timeFrameToString(timeFrame)+" DT osc channel ("+RsxLength+","+PeriodStoch+","+PeriodSK+","+PeriodSD+")");
return(0);
}

//
//
//
//
//

int deinit(){  if (!calculateValue && ShowArrows) deleteArrows();  return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int i,r,limit;
   int counted_bars = IndicatorCounted();

   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
             limit=MathMin(Bars-counted_bars,Bars-1);
             if (ArrayRange(wrkBuffer,0) != Bars) { ArrayResize(wrkBuffer,Bars); ArrayResize(stored,Bars); }
             if (returnBars) { SK[0] = limit; return(0); }
             
   //
   //
   //
   //
   //

   if (calculateValue || timeFrame == Period())
   {
     double Kg = (3.0)/(2.0+RsxLength);
     double Hg = 1.0-Kg; 
     for(i=limit, r=Bars-i-1; i>=0; i--, r++)
     {
        wrkBuffer[r][12] = iAverage(iMA(NULL,0,1,0,MODE_SMA,PRICE_CLOSE,i),OmaLength,OmaSpeed,OmaAdaptive,r);
        if (i==(Bars-1)) { for (int c=0; c<12; c++) wrkBuffer[r][c] = 0; continue; }  

        //
        //
        //
        //
        //
      
        double roc = wrkBuffer[r][12]-wrkBuffer[r-1][12];
        double roa = MathAbs(roc);
        for (int k=0; k<3; k++)
        {
           int kk = k*2;
              wrkBuffer[r][kk+0] = Kg*roc                + Hg*wrkBuffer[r-1][kk+0];
              wrkBuffer[r][kk+1] = Kg*wrkBuffer[r][kk+0] + Hg*wrkBuffer[r-1][kk+1]; roc = 1.5*wrkBuffer[r][kk+0] - 0.5 * wrkBuffer[r][kk+1];
              wrkBuffer[r][kk+6] = Kg*roa                + Hg*wrkBuffer[r-1][kk+6];
              wrkBuffer[r][kk+7] = Kg*wrkBuffer[r][kk+6] + Hg*wrkBuffer[r-1][kk+7]; roa = 1.5*wrkBuffer[r][kk+6] - 0.5 * wrkBuffer[r][kk+7];
        }
        if (roa != 0)
             rsx[i] = MathMax(MathMin((roc/roa+1.0)*50.0,100.00),0.00); 
        else rsx[i] = 50.0;
        
        //
        //
        //
        //
        //
        
        double LLV = rsx[ArrayMinimum(rsx,PeriodStoch,i)];
        double HHV = rsx[ArrayMaximum(rsx,PeriodStoch,i)];
        if ((HHV-LLV)!=0)
              storsx[i] = 100.0*((rsx[i] - LLV)/(HHV - LLV));
        else  storsx[i] = 0;
        
        LowBuffer[i] = storsx[ArrayMinimum(storsx,HighLowPeriod,i)];
        HighBuffer[i]= storsx[ArrayMaximum(storsx,HighLowPeriod,i)]; 
        
        //
        //
        //
        //
        //
        
        
   }
   for(i=limit; i>=0; i--) SK[i] = iMAOnArray(storsx,0,PeriodSK,0,MAMode,i);     
   for(i=limit; i>=0; i--)
   { 
      SD[i]    = iMAOnArray(SK,0,PeriodSD,0,MAMode,i);
      trend[i] = trend[i+1];
      if (SK[i] > SD[i] && NormalizeDouble(SD[i+1],Digits) == 0   && NormalizeDouble(SD[i],Digits) >   0) trend[i] =  1;
      if (SK[i] < SD[i] && NormalizeDouble(SD[i+1],Digits) == 100 && NormalizeDouble(SD[i],Digits) < 100) trend[i] = -1; 
      if (!calculateValue) manageArrow(i);
         
   }         
   manageAlerts();
   return(0);      
   }
   
       //
       //
       //
       //
       //
   
       limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,IndicatorFileName,"returnBars",0,0)*timeFrame/Period()));
       
       for(i=limit; i>=0; i--)
       {
       
          int y = iBarShift(NULL,timeFrame,Time[i]);
              SK[i]         = iCustom(NULL,timeFrame,IndicatorFileName,"calculateValue",RsxLength,OmaLength,OmaSpeed,OmaAdaptive,PeriodStoch,PeriodSK,PeriodSD,HighLowPeriod,ShowChannel,MAMode,0,y);
              SD[i]         = iCustom(NULL,timeFrame,IndicatorFileName,"calculateValue",RsxLength,OmaLength,OmaSpeed,OmaAdaptive,PeriodStoch,PeriodSK,PeriodSD,HighLowPeriod,ShowChannel,MAMode,1,y);
              LowBuffer[i]  = iCustom(NULL,timeFrame,IndicatorFileName,"calculateValue",RsxLength,OmaLength,OmaSpeed,OmaAdaptive,PeriodStoch,PeriodSK,PeriodSD,HighLowPeriod,ShowChannel,MAMode,2,y);
              HighBuffer[i] = iCustom(NULL,timeFrame,IndicatorFileName,"calculateValue",RsxLength,OmaLength,OmaSpeed,OmaAdaptive,PeriodStoch,PeriodSK,PeriodSD,HighLowPeriod,ShowChannel,MAMode,3,y);
              trend[i]      = iCustom(NULL,timeFrame,IndicatorFileName,"calculateValue",RsxLength,OmaLength,OmaSpeed,OmaAdaptive,PeriodStoch,PeriodSK,PeriodSD,HighLowPeriod,ShowChannel,MAMode,6,y);
              
              manageArrow(i); 
               
              //
              //
              //
              //
              //
      
              if (timeFrame <= Period() || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;
              if (!Interpolate) continue;

              //
              //
              //
              //
              //

              datetime time = iTime(NULL,timeFrame,y);
                 for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
                 for(int j = 1; j < n; j++)
                 {
                
                    SK[i+j]        = SK[i]        + (SK[i+n]        - SK[i]        )* j/n;
                    SD[i+j]        = SD[i]        + (SD[i+n]        - SD[i]        )* j/n;
                    LowBuffer[i+j] = LowBuffer[i] + (LowBuffer[i+n] - LowBuffer[i] )* j/n;
                    HighBuffer[i+j]= HighBuffer[i]+ (HighBuffer[i+n]- HighBuffer[i])* j/n;    
                }               
       }               

       //
       //
       //
       //
       //
       
       manageAlerts();
             
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

#define E1  0
#define E2  1
#define E3  2
#define E4  3
#define E5  4
#define E6  5
#define res 6

//
//
//
//
//

double iAverage(double price, double averagePeriod, double tconst, bool adaptive, int r, int ashift=0)
{
   double e1=stored[r-1][E1+ashift];  double e2=stored[r-1][E2+ashift];
   double e3=stored[r-1][E3+ashift];  double e4=stored[r-1][E4+ashift];
   double e5=stored[r-1][E5+ashift];  double e6=stored[r-1][E6+ashift];

   //
   //
   //
   //
   //

      if (adaptive && (averagePeriod > 1))
      {
         double minPeriod = averagePeriod/2.0;
         double maxPeriod = minPeriod*5.0;
         int    endPeriod = MathCeil(maxPeriod);
         double signal    = MathAbs((price-stored[r-endPeriod][res]));
         double noise     = 0.00000000001;

            for(int k=1; k<endPeriod; k++) noise=noise+MathAbs(price-stored[r-k][res]);

         averagePeriod = ((signal/noise)*(maxPeriod-minPeriod))+minPeriod;
      }
      
      //
      //
      //
      //
      //
      
      double alpha = (2.0+tconst)/(1.0+tconst+averagePeriod);

      e1 = e1 + alpha*(price-e1); e2 = e2 + alpha*(e1-e2); double v1 = 1.5 * e1 - 0.5 * e2;
      e3 = e3 + alpha*(v1   -e3); e4 = e4 + alpha*(e3-e4); double v2 = 1.5 * e3 - 0.5 * e4;
      e5 = e5 + alpha*(v2   -e5); e6 = e6 + alpha*(e5-e6); double v3 = 1.5 * e5 - 0.5 * e6;

   //
   //
   //
   //
   //

   stored[r][E1+ashift]  = e1;  stored[r][E2+ashift] = e2;
   stored[r][E3+ashift]  = e3;  stored[r][E4+ashift] = e4;
   stored[r][E5+ashift]  = e5;  stored[r][E6+ashift] = e6;
   stored[r][res+ashift] = price;
   return(v3);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

string sTfTable[] = {"M1","M5","M10","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,10,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageArrow(int i)
{
   if (ShowArrows)
   {
      deleteArrow(Time[i]);
      if (trend[i]!=trend[i+1])
      {
         if (trend[i] == 1) drawArrow(i,arrowsUpColor,221,false);
         if (trend[i] ==-1) drawArrow(i,arrowsDnColor,222,true );
      }
   }
}               

//
//
//
//
//

void drawArrow(int i,color theColor,int theCode,bool up)
{
   string name = arrowsIdentifier+":"+Time[i];
   double gap  = 2.0*iATR(NULL,0,20,i)/4.0;//3.0*
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i]+gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i] -gap);
}

//
//
//
//
//

void deleteArrows()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}
void deleteArrow(datetime time)
{
   string lookFor = arrowsIdentifier+":"+time; ObjectDelete(lookFor);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"up");
         if (trend[whichBar] ==-1) doAlert(whichBar,"down");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," dtosc trend changed to ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"dtosc "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}

